package cn.com.qmth.stmms.biz.distributpaper.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import cn.com.qmth.stmms.biz.exam.model.Marker;
import cn.com.qmth.stmms.common.enums.HistoryType;

@Entity
@Table(name = "m_formally_history")
public class FormallyHistory implements Serializable {

    private static final long serialVersionUID = 1751016902951510338L;

    @Id
    @GeneratedValue
    private Integer id;

    /**
     * 正评库ID
     */
    @Column(name = "library_id")
    private Integer libraryId;

    /**
     * 一评，二评
     */
    @Column(name = "stage")
    private Integer stage;

    /**
     * 评卷人
     */
    @Column(name = "scorer")
    private Integer scorer;

    /**
     * 给分时间
     */
    @Column(name = "score_time")
    private Date scoreTime;

    /**
     * 总得分
     */
    @Column(name = "total_score")
    private Double totalScore;

    /**
     * 分值列表
     */
    @Column(name = "score_list")
    private String scoreList;

    /**
     * 所花时间，以秒为单位
     */
    @Column(name = "spent")
    private Long spent;

    /**
     * 类型
     */
    @Column(name = "type")
    @Enumerated(EnumType.ORDINAL)
    private HistoryType type;

    @Transient
    private Marker marker;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getLibraryId() {
        return libraryId;
    }

    public void setLibraryId(Integer libraryId) {
        this.libraryId = libraryId;
    }

    public Integer getStage() {
        return stage;
    }

    public void setStage(Integer stage) {
        this.stage = stage;
    }

    public Integer getScorer() {
        return scorer;
    }

    public void setScorer(Integer scorer) {
        this.scorer = scorer;
    }

    public Date getScoreTime() {
        return scoreTime;
    }

    public void setScoreTime(Date scoreTime) {
        this.scoreTime = scoreTime;
    }

    public Double getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(Double totalScore) {
        this.totalScore = totalScore;
    }

    public String getScoreList() {
        return scoreList;
    }

    public void setScoreList(String scoreList) {
        this.scoreList = scoreList;
    }

    public Long getSpent() {
        return spent;
    }

    public void setSpent(Long spent) {
        this.spent = spent;
    }

    public HistoryType getType() {
        return type;
    }

    public void setType(HistoryType type) {
        this.type = type;
    }

    public Marker getMarker() {
        return marker;
    }

    public void setMarker(Marker marker) {
        this.marker = marker;
    }

}
