package cn.com.qmth.stmms.biz.subjectheader.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import cn.com.qmth.stmms.common.enums.LibraryStatus;
import cn.com.qmth.stmms.common.enums.LibraryType;

@Entity
@Table(name = "m_random_history")
public class RandomHistory implements Serializable {

    private static final long serialVersionUID = 7233107543719920269L;

    @Id
    @GeneratedValue
    private Integer id;

    /**
     * 抽查库ID
     */
    @Column(name = "library_id")
    private Integer libraryId;

    /**
     * 提交人
     */
    @Column(name = "submitter")
    private Integer submitter;

    /**
     * 领卷时间
     */
    @Column(name = "submit_time")
    private Date submitTime;

    /**
     * 总得分
     */
    @Column(name = "total_score")
    private Double totalScore;

    /**
     * 分值列表
     */
    @Column(name = "score_list")
    private String scoreList;

    /**
     * 所花时间，以秒为单位
     */
    @Column(name = "spent")
    private Long spent;

    /**
     * 状态：1给分2打回重评
     */
    @Enumerated(EnumType.ORDINAL)
    @Column(name = "status")
    private LibraryStatus status;

    /**
     * 类型：1：试评2：正评
     */
    @Enumerated(EnumType.ORDINAL)
    @Column(name = "type")
    private LibraryType type;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getLibraryId() {
        return libraryId;
    }

    public void setLibraryId(Integer libraryId) {
        this.libraryId = libraryId;
    }

    public Integer getSubmitter() {
        return submitter;
    }

    public void setSubmitter(Integer submitter) {
        this.submitter = submitter;
    }

    public Date getSubmitTime() {
        return submitTime;
    }

    public void setSubmitTime(Date submitTime) {
        this.submitTime = submitTime;
    }

    public Double getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(Double totalScore) {
        this.totalScore = totalScore;
    }

    public String getScoreList() {
        return scoreList;
    }

    public void setScoreList(String scoreList) {
        this.scoreList = scoreList;
    }

    public Long getSpent() {
        return spent;
    }

    public void setSpent(Long spent) {
        this.spent = spent;
    }

    public LibraryStatus getStatus() {
        return status;
    }

    public void setStatus(LibraryStatus status) {
        this.status = status;
    }

    public LibraryType getType() {
        return type;
    }

    public void setType(LibraryType type) {
        this.type = type;
    }

}
